/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Indexes;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TInputHelp.TInputHelpPath;
import de.ship.db.tables.TInputType.TInputTypePath;
import de.ship.db.tables.records.TInputVariableRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TInputVariable extends TableImpl<TInputVariableRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_input_variable</code>
     */
    public static final TInputVariable T_INPUT_VARIABLE = new TInputVariable();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TInputVariableRecord> getRecordType() {
        return TInputVariableRecord.class;
    }

    /**
     * The column <code>common_dd.t_input_variable.pk_input_variable</code>.
     */
    public final TableField<TInputVariableRecord, Integer> PK_INPUT_VARIABLE = createField(DSL.name("pk_input_variable"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_input_variable.fk_variable</code>.
     */
    public final TableField<TInputVariableRecord, Integer> FK_VARIABLE = createField(DSL.name("fk_variable"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_input_variable.var_order</code>. input order
     * inside of this variable group
     */
    public final TableField<TInputVariableRecord, Integer> VAR_ORDER = createField(DSL.name("var_order"), SQLDataType.INTEGER, this, "input order inside of this variable group");

    /**
     * The column <code>common_dd.t_input_variable.var_ecrf</code>. visibility
     * on data input; 1 = yes (default), 0 = no (decativated)
     */
    public final TableField<TInputVariableRecord, Integer> VAR_ECRF = createField(DSL.name("var_ecrf"), SQLDataType.INTEGER.nullable(false), this, "visibility on data input; 1 = yes (default), 0 = no (decativated)");

    /**
     * The column <code>common_dd.t_input_variable.var_formposx</code>. x
     * position of this element
     */
    public final TableField<TInputVariableRecord, Integer> VAR_FORMPOSX = createField(DSL.name("var_formposx"), SQLDataType.INTEGER, this, "x position of this element");

    /**
     * The column <code>common_dd.t_input_variable.var_formposy</code>. y
     * position of this element
     */
    public final TableField<TInputVariableRecord, Integer> VAR_FORMPOSY = createField(DSL.name("var_formposy"), SQLDataType.INTEGER, this, "y position of this element");

    /**
     * The column <code>common_dd.t_input_variable.fk_var_inputtype</code>.
     */
    public final TableField<TInputVariableRecord, Integer> FK_VAR_INPUTTYPE = createField(DSL.name("fk_var_inputtype"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_input_variable.default_value</code>. default
     * value; must be number if used
     */
    public final TableField<TInputVariableRecord, Integer> DEFAULT_VALUE = createField(DSL.name("default_value"), SQLDataType.INTEGER, this, "default value; must be number if used");

    /**
     * The column <code>common_dd.t_input_variable.fk_var_inputhelp</code>.
     */
    public final TableField<TInputVariableRecord, Integer> FK_VAR_INPUTHELP = createField(DSL.name("fk_var_inputhelp"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.t_input_variable.label_position</code>.
     * position of label; 0 = none, 1 = left, 2 = top, 3 = right, 4 = bottom
     */
    public final TableField<TInputVariableRecord, Integer> LABEL_POSITION = createField(DSL.name("label_position"), SQLDataType.INTEGER.nullable(false), this, "position of label; 0 = none, 1 = left, 2 = top, 3 = right, 4 = bottom");

    /**
     * The column <code>common_dd.t_input_variable.lastchange</code>.
     */
    public final TableField<TInputVariableRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_input_variable.required</code>.
     */
    public final TableField<TInputVariableRecord, Boolean> REQUIRED = createField(DSL.name("required"), SQLDataType.BOOLEAN.defaultValue(DSL.field(DSL.raw("true"), SQLDataType.BOOLEAN)), this, "");

    private TInputVariable(Name alias, Table<TInputVariableRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TInputVariable(Name alias, Table<TInputVariableRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_input_variable</code> table reference
     */
    public TInputVariable(String alias) {
        this(DSL.name(alias), T_INPUT_VARIABLE);
    }

    /**
     * Create an aliased <code>common_dd.t_input_variable</code> table reference
     */
    public TInputVariable(Name alias) {
        this(alias, T_INPUT_VARIABLE);
    }

    /**
     * Create a <code>common_dd.t_input_variable</code> table reference
     */
    public TInputVariable() {
        this(DSL.name("t_input_variable"), null);
    }

    public <O extends Record> TInputVariable(Table<O> path, ForeignKey<O, TInputVariableRecord> childPath, InverseForeignKey<O, TInputVariableRecord> parentPath) {
        super(path, childPath, parentPath, T_INPUT_VARIABLE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TInputVariablePath extends TInputVariable implements Path<TInputVariableRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TInputVariablePath(Table<O> path, ForeignKey<O, TInputVariableRecord> childPath, InverseForeignKey<O, TInputVariableRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TInputVariablePath(Name alias, Table<TInputVariableRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TInputVariablePath as(String alias) {
            return new TInputVariablePath(DSL.name(alias), this);
        }

        @Override
        public TInputVariablePath as(Name alias) {
            return new TInputVariablePath(alias, this);
        }

        @Override
        public TInputVariablePath as(Table<?> alias) {
            return new TInputVariablePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public List<Index> getIndexes() {
        return Arrays.asList(Indexes.T_INPUT_VARIABLE_FK_VAR_INPUTTYPE_IDX);
    }

    @Override
    public Identity<TInputVariableRecord, Integer> getIdentity() {
        return (Identity<TInputVariableRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TInputVariableRecord> getPrimaryKey() {
        return Keys.PK_INPUT_VARIABLE;
    }

    @Override
    public List<UniqueKey<TInputVariableRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_FK_VARIABLE);
    }

    @Override
    public List<ForeignKey<TInputVariableRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_INPUT_VARIABLE__FK_INPUT_VARIABLE, Keys.T_INPUT_VARIABLE__FK_INPUTVAR_INPUTTYPE, Keys.T_INPUT_VARIABLE__FK_INPUTVAR_INPUTHELP);
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_INPUT_VARIABLE__FK_INPUT_VARIABLE, null);

        return _tCoreElementHierarchy;
    }

    private transient TInputTypePath _tInputType;

    /**
     * Get the implicit join path to the <code>common_dd.t_input_type</code>
     * table.
     */
    public TInputTypePath tInputType() {
        if (_tInputType == null)
            _tInputType = new TInputTypePath(this, Keys.T_INPUT_VARIABLE__FK_INPUTVAR_INPUTTYPE, null);

        return _tInputType;
    }

    private transient TInputHelpPath _tInputHelp;

    /**
     * Get the implicit join path to the <code>common_dd.t_input_help</code>
     * table.
     */
    public TInputHelpPath tInputHelp() {
        if (_tInputHelp == null)
            _tInputHelp = new TInputHelpPath(this, Keys.T_INPUT_VARIABLE__FK_INPUTVAR_INPUTHELP, null);

        return _tInputHelp;
    }

    @Override
    public TInputVariable as(String alias) {
        return new TInputVariable(DSL.name(alias), this);
    }

    @Override
    public TInputVariable as(Name alias) {
        return new TInputVariable(alias, this);
    }

    @Override
    public TInputVariable as(Table<?> alias) {
        return new TInputVariable(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputVariable rename(String name) {
        return new TInputVariable(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputVariable rename(Name name) {
        return new TInputVariable(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputVariable rename(Table<?> name) {
        return new TInputVariable(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputVariable where(Condition condition) {
        return new TInputVariable(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputVariable where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputVariable where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputVariable where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputVariable where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputVariable where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputVariable where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputVariable where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputVariable whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputVariable whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
